#include "gen_random.hpp"

#include "common.hpp"

#include <stdio.h>

void gen_random (int numbits, mpz_t x)
{
  printf("generating a random number ...");
  fflush (stdout);

  FILE *devrandom;
  assert ((devrandom = fopen ("/dev/random", "r"))!=0);

  int entropy = 0; // assignment unneccesary but to avoid warning
  int curmask = 256;
  mpz_set_ui (x, 1);
  for (int i=0; i<numbits-1; i++) {
    mpz_mul_2exp (x, x, 1);
    if (curmask == 256) {
      assert ((entropy = fgetc (devrandom))!=EOF);
      curmask = 1;
    };
    if (entropy&curmask) mpz_add_ui (x, x, 1);
    curmask <<= 1;
  };

  assert (fclose(devrandom)==0);

  printf("... done\n");
};

void gen_deterministic_random (int numbits, mpz_t x)
{
  FILE *devrandom;
  assert ((devrandom = fopen ("/dev/urandom", "r"))!=0);

  int entropy = 0; // assignment unneccesary but to avoid warning
  int curmask = 256;
  mpz_set_ui (x, 1);
  for (int i=0; i<numbits-1; i++) {
    mpz_mul_2exp (x, x, 1);
    if (curmask == 256) {
      assert ((entropy = fgetc (devrandom))!=EOF);
      curmask = 1;
    };
    if (entropy&curmask) mpz_add_ui (x, x, 1);
    curmask <<= 1;
  };

  assert (fclose(devrandom)==0);
};
