#include "seek_bigger_prime.hpp"

#include "primes.hpp"

#include <stdio.h>

inline void find_in_primes_table (mpz_t x)
{
  int i=0;
  while (mpz_cmp_ui (x, primes[i]) > 0) i++;
  mpz_set_ui (x, primes[i]);
};

inline void seek_really_big_prime (mpz_t x)
{
  mpz_t a;
  mpz_init (a);

  printf ("Seeking next prime number ");
  fflush (stdout);

  mpz_setbit (x,0); // if (even(x)) x++;

  for (;;) {
    for (int i=1; i<primes_count; i++) { // do not check for 2, so i=1
      mpz_tdiv_r_ui(a, x, primes[i]);
      if (!mpz_sgn(a)) {
	// printf("T");fflush(stdout);
	// ^ cool to watch, but you can derive the number by observing
	// the screen output !!!
	goto isnoprime;
      };
    };
    if (mpz_probab_prime_p (x, 100)) break;
    printf(".");fflush(stdout);
  isnoprime:
    mpz_add_ui (x, x, 2);
  };

  mpz_clear (a);

  printf (" done\n");
};

void seek_bigger_prime (mpz_t x)
{
  if (mpz_cmp_ui (x, primes[primes_count-1]) <= 0)
    find_in_primes_table (x);
  else
    seek_really_big_prime (x);
};
